diff -urpN libvirt-0.2.0.orig/qemud/bridge.c libvirt-0.2.0/qemud/bridge.c
--- libvirt-0.2.0.orig/qemud/bridge.c	2007-02-15 01:02:40.000000000 +0900
+++ libvirt-0.2.0/qemud/bridge.c	2007-02-16 15:53:46.000000000 +0900
@@ -341,8 +341,8 @@ brSetInetAddr(brControl *ctl,
     else if (ret == 0)
         return EINVAL;
 
-    ((struct sockaddr_in *)&ifr.ifr_addr)->sin_family = AF_INET;
-    ((struct sockaddr_in *)&ifr.ifr_addr)->sin_addr   = inaddr;
+    ((struct sockaddr_in *)((void *)&ifr.ifr_addr))->sin_family = AF_INET;
+    ((struct sockaddr_in *)((void *)&ifr.ifr_addr))->sin_addr   = inaddr;
 
     if (ioctl(ctl->fd, cmd, &ifr) < 0)
         return errno;
@@ -378,7 +378,7 @@ brGetInetAddr(brControl *ctl,
     if (maxlen < BR_INET_ADDR_MAXLEN || ifr.ifr_addr.sa_family != AF_INET)
         return EFAULT;
 
-    inaddr = &((struct sockaddr_in *)&ifr.ifr_addr)->sin_addr;
+    inaddr = &((struct sockaddr_in *)((void *)&ifr.ifr_addr))->sin_addr;
 
     if (!inet_ntop(AF_INET, inaddr, addr, maxlen))
         return errno;
diff -urpN libvirt-0.2.0.orig/qemud/conf.c libvirt-0.2.0/qemud/conf.c
--- libvirt-0.2.0.orig/qemud/conf.c	2007-02-15 02:12:25.000000000 +0900
+++ libvirt-0.2.0/qemud/conf.c	2007-02-16 15:53:54.000000000 +0900
@@ -446,13 +446,20 @@ static struct qemud_vm_net_def *qemudPar
     net->vlan = 0;
 
     if (macaddr) {
+        unsigned int mac[6];
         sscanf((const char *)macaddr, "%02x:%02x:%02x:%02x:%02x:%02x",
-               (unsigned int*)&net->mac[0],
-               (unsigned int*)&net->mac[1],
-               (unsigned int*)&net->mac[2],
-               (unsigned int*)&net->mac[3],
-               (unsigned int*)&net->mac[4],
-               (unsigned int*)&net->mac[5]);
+               (unsigned int*)&mac[0],
+               (unsigned int*)&mac[1],
+               (unsigned int*)&mac[2],
+               (unsigned int*)&mac[3],
+               (unsigned int*)&mac[4],
+               (unsigned int*)&mac[5]);
+        net->mac[0] = mac[0];
+        net->mac[1] = mac[1];
+        net->mac[2] = mac[2];
+        net->mac[3] = mac[3];
+        net->mac[4] = mac[4];
+        net->mac[5] = mac[5];
 
         xmlFree(macaddr);
     }
